 
/* Program 1.1 for Bisection Method 
by Dr. RM. Somasundaram & Rm. Chandrasekaran
*/
class Bisec
{
public:
double lower_bound;
double upper_bound;
double epsilon;
public:
double formula(double key);
void calculateRoot(Bisec aBisec,double& fa,double&
x0,double& fx0);
};
//#includebisec.h
#include<iostream.h>
#include<math.h>
static int maxIteration=100;
double Bisec::formula(double key)
{ 
// double retVal=exp(-key)-key; 
// Book PBM : x*x*x - x - 1 
double retVal = (key * key * key) - key -1; 
return retVal; 
} 
void Bisec::calculateRoot(Bisec aBisec,double& fa,double& x0,double& fx0)
{
fa = aBisec.formula(aBisec.lower_bound);
x0 = 0.5*(aBisec.lower_bound+aBisec.upper_bound);
fx0 = aBisec.formula(x0);
}
main()
{
Bisec aBisec;
int iteration=1;
double fa = 0.0;
double x0 = 0.0;
double fx0 = 0.0;
double iterations,calculated;
double initialLowerBound=0.0;
double initialUpperBound=0.0;
cout<<\n\tInput values for lower bound enclosing root :;
cin>>aBisec.lower_bound;
cout<<\n\tInput values for Upper bound enclosing root :;
cin>>aBisec.upper_bound;
cout<<\n\tInput values for tolerance :;
cin>>aBisec.epsilon;
initialLowerBound=aBisec.lower_bound;
initialUpperBound=aBisec.upper_bound;
cout<<\n\tRange in which the root id expected
:<<initialLowerBound<<,;
cout<<initialUpperBound<<endl;
cout<<\n\tThe value of epsilon :<<aBisec.epsilon<<endl;
aBisec.calculateRoot(aBisec,fa,x0,fx0);
while(fabs (fx0) > aBisec.epsilon)
{ 
if ( fa*fx0 < 0) 
{
aBisec.upper_bound=x0;
iteration += 1;
if(iteration > maxIteration)
{
cout<<No convergence
in<<iteration<<iterations,calculated;
cout<<Nearest root = <<x0<<endl;
break;
}
aBisec.calculateRoot(aBisec,fa,x0,fx0); 
} 
else 
{
aBisec.lower_bound = x0;
iteration += 1;
if(iteration > maxIteration)
{
cout<<No convergence
in<<iteration<<iterations,calculated;
cout<<Nearest root = <<x0<<endl;
break;
}
aBisec.calculateRoot(aBisec,fa,x0,fx0);
} 
}

if (iteration <= maxIteration){ 
cout<<\n\tRoot =<<x0<< in <<iteration<< iterations.<<endl; 
} 
return 0; 
} 
