/* Program 1.5 Secant Method
by Dr. RM. Somasundaram & Rm. Chandrasekaran */
class Secant
{
public :
double lower_bound;
double upper_bound;
double epsilon;
public :
double formula(double key);
};
#include<stdio.h>
#include<iostream.h>
#include<math.h>
static int maxIteration=100;
double Secant::formula(double key)
{
double retval=cos(key)+3-(2*key);
return retval;
}
main()
{
Secant aSecant;
int iteration=1;
double fx0=0.0;
double fx1=0.0;
int i=0;
double x[100];
double h=0.0;
double t=0.0;
double tm=0.0;
double initialLowerBound=0.0;
double initialUpperBound=0.0;
cout<<"\n\tInput values for lower bound enclosing root :";
cin>>aSecant.lower_bound;
cout<<"\n\tInput values for lower bound enclosing root :";
cin>>aSecant.upper_bound;
cout<<"\n\tInput values for Tolerence :";
cin>>aSecant.epsilon;
initialLowerBound=aSecant.lower_bound;
initialUpperBound=aSecant.upper_bound;
cout<<"\n\tRange in which the root is expected :"<<"["<<initialLowerBound<<",";
cout<<initialUpperBound<<"]"<<endl;
cout<<"\n\tThe valur of Epsilon :"<<aSecant.epsilon<<endl;
x[0]=initialLowerBound;
x[1]=initialUpperBound;
for(i=1;i<maxIteration;i++)
{
t = x[i];
tm= x[i-1];
fx0=aSecant.formula(tm);
fx1=aSecant.formula(t);
h=(t-tm)*fx1/(fx1-fx0);
if( fabs( h ) < aSecant.epsilon)
{
cout<<"\n\tConvergence acheived in "<< i <<" steps "<<endl;
printf("\n x[i] \t\t\t x[i-1] \n\n");
printf("\n\n");
for(int k=1;k<=i;k++)
{
printf("%f \t\t %f \n",x[k],x[k-1]);
}
break;
}
else
{
x[i+1]=x[i]-h;
continue;
}
}

if(i== maxIteration)
{
cout<<"\n\tNo convergence in "<< i <<" steps "<<x[i]<<endl;
}
return 0;
}
/* Input and Output for the above Program
Input values for lower bound enclosing root :0
Input values for lower bound enclosing root :1.5
Input values for Tolerence :0.00001
Range in which the root is expected :[0,1.5]
The valur of Epsilon :1e-05
Convergence acheived in 3 steps
x[i] x[i-1]

1.500000 0.000000
1.527004 1.500000
1.523592 1.527004
*/