/* Program 2.3 by GAUSS Jordan with Pivotal Condensation
by Dr. RM. Somasundaram & Rm. Chandrasekaran */
#include<stdio.h>
#include<iostream.h>
#include<math.h>
#include<conio.h>
class GJPC
{
public :
double a[10][10],x[10];

public :
void computeSolution(int n);
};
void GJPC::computeSolution(int n)
{
int i,j,k,jj,kp;
double quot,big,ab,t;
int np = n+1;
int nm = n-1;
cout<<"Value of n"<<n<<endl;
for(k=1;k<=n;k++)
{
jj=k;
big=fabs(a[k][k]);
kp=k+1;
for(i=kp;i<=n;i++)
{
ab=fabs(a[i][k]);
if((big-ab) < 0)
{
big=ab;
jj=i;
}
else
{
continue;
}
}
for(j=k;j<=np;j++)
{
t=a[jj][j];
a[jj][j]=a[k][j];
a[k][j]=t;
}
for(i=1;i<=n;i++)
{ if(i==k)
{
continue;
}
quot=a[i][k]/a[k][k];
for(j=kp;j<=np;j++)
{
for(j=k;j<=np;j++)
{
a[i][j]=a[i][j]-quot * a[k][j];
}
}
}

for(i=kp;i<n;i++)
{
a[i][k]=0;
}
for(i=1;i<=n;i++)
{
for(j=1;j<=np;j++)
{
cout<<a[i][j]<<" ";
}
cout<<endl;
for(i=1;i<=n;i++)
{
x[i]=a[i][np]/a[i][i];
}
}
}
}
void main()
{
GJPC aGJPC;
int n,i,j;
clrscr();
cout<<"\n\t Input Number of Unknown :";
cin>>n;
cout<<"\n\t Input values of Augmented matrix rowwise :";
for(i=1;i<=n;i++)
{
for(j=1;j<=n+1;j++)
{
cin>>aGJPC.a[i][j];
}
}
cout<<"\n\t Given Augmented Matrix is \n";
for(i=1;i<=n;i++)
{
for(j=1;j<=n+1;j++)
{
cout<<aGJPC.a[i][j]<<"\t";
}
cout<<endl;
}
aGJPC.computeSolution(n);
for(i=1;i<=n;i++)
{
cout<<aGJPC.x[i]<<"\t"<<endl;
}
getch();
}
/*
Input and output for Solution of System of Equations
Enter The number of Equations : 3
Enter the Input Matrix :
3 4 -7
7 -1 2
1 10 -2
Enter the RHS values :
23 -14 33
ECHO CHECK OF MATRIX
3 4 -7
7 -1 2
1 10 -2
ECHO CHECK OF INPUT VECTORS
23 -14 33
*** SOLUTION VECTOR ***
-1 3 -2
*/