/* Program 2.7 Largest Eigen Value by Power Method
by Dr. RM. Somasundaram & Rm. Chandrasekaran
*/
#include<stdio.h>
#include<iostream.h>
#include<math.h>
#include<conio.h>
enum bool {flag,false=0,true=1};
class EIGEN
{
public :
double a[10][10],y[10],z[10],al[10];
int n;
double ep;
bool flag;
public :
void doProcessing(bool& flag,int n);
double zm( int i1,double u[]);
};
double EIGEN::zm(int i1,double u[])
{
double big = u[1];
for(int i=2;i<=i1;i++)
{
if((big-u[i])<0.0)
{
big=u[i];
}
}
return big;
}
void EIGEN::doProcessing(bool& flag,int kmax)
{
int i,j,k;
double sum;
for(k=1;k<=kmax;k++)
{
for(i=1;i<=n;i++)
{
sum=0.0;
for(j=1;j<=n;j++)
{
sum +=a[i][j] * y[j];
}
z[i]=sum;
}
cout<<"z[i]"<<endl;
for(i=1;i<=n;i++)
{
cout<<z[i]<<endl;
}
cout<<endl;

al[k]=zm(n,z);
cout<<"al["<<k<<"]="<<al[k]<<endl;
for(i=1;i<=n;i++)
{
y[i]=z[i]/al[k];
}
cout<<"y[i]="<<endl;
for(i=1;i<=n;i++)
{
cout<<y[i]<<" ";
}
cout<<endl;
if(k==1)
{
continue;
}
else if(fabs(al[k] - al[k-1])< ep)
{
flag=true;
break;
}
}
if(flag=true)
{
cout<<"\n\t Convergence acheived "<<endl;
cout<<"\n\t The abs largest eigenvalues="<<endl;
for(i=1;i<=k;i++)
{
cout<<al[i]<<" ";
}
cout<<endl;
}
else
{
cout<<"\n\t No Convergence in steps="<<kmax<<endl;
}
}
int main()
{
EIGEN aEIGEN;
int k,i=0,j=0,n=0;
bool flag = false;
int kmax=20;
cout<<"\n\t Enter Tolerence :";
cin>>aEIGEN.ep;
cout<<"\n\t Enter values of n :";
cin>>aEIGEN.n;
n=aEIGEN.n;
cout<<"\n\t Enter matrix a[i][j] :"<<endl;
for(i=1;i<=n;i++)
{
for(j=1;j<=n;j++)
{
cin>>aEIGEN.a[i][j];
}
}
for(i=1;i<=n;i++)
{
for(j=1;j<=n;j++)
{
cout<<aEIGEN.a[i][j]<<" ";
}
cout<<endl;
}
cout<<"\n\t Enter the Guess Vector :"<<endl;
for(i=1;i<=n;i++)
{
cin>>aEIGEN.y[i];
}
for(i=1;i<=n;i++)
{
cout<<aEIGEN.y[i]<<" ";
}
cout<<endl;
aEIGEN.doProcessing(flag,kmax);
getch();
}
/*
________________________________________________________________________________
Enter Tolerence :0.00001
Enter values of n :3
Enter matrix a[i][j] :
1 1 2
0 1 3
1 1 1
1 1 2
0 1 3
1 1 1
Enter the Guess Vector :
1 1 1
1 1 0.75
1 0.928571 0.785714
1 0.938776 0.77551
Appendix 194
Convergence acheived
The abs largest eigenvalues=
4 3.5 3.5
*/