/* Program 7.1 Trapezoidal Rule for Evaluating an Integral
by Dr. RM. Somasundaram & Rm. Chandrasekaran */
class Trap1
{
public :
double a;
double b;
double epsilon;
public :
double formula(double index);
};
#include<stdio.h>
#include<iostream.h>
#include<math.h>
double Trap1::formula(double index)
{
return exp(-(index*index));
}
main()
{
Trap1 aTrap1;
double x[100],temp[100];
int n = 10;
int j = 0;
double h = 0.0,ends=0.0;
double tempDouble = 0.0;
double sum=0.0,sum1=0.0,sum2=0.0;
double error=0.0;
cout<<"\n\tEnter the value of a :";
cin>>aTrap1.a;
cout<<"\n\tEnter the value of b :";
cin>>aTrap1.b;
h=(aTrap1.b-aTrap1.a)/n;
tempDouble=aTrap1.formula(aTrap1.b);
ends=1.0 + tempDouble;
for(j=1;j<=(n-1);j++)
{
x[j]=aTrap1.a + j*h;
temp[j]=aTrap1.formula(x[j]);
sum=sum + 1.0 * temp[j];
cout<<"sum[h]="<<sum1<<",sum[2h]="<<sum2<<",Error="<<error<<endl;
}
sum1= 0.5 * (ends + sum) *h;
sum=0.0;
for(j=2;j<=(n-2);j=j+2)
{
sum=sum + 2.0 * temp[j];
cout<<"sum[h]="<<sum1<<",sum[2h]="<<sum2<<",Error="<<error<<endl;
}
sum2= h * (ends + sum);
error = fabs((sum2-sum1))/3;
cout<<"a="<<aTrap1.a<<",b="<<aTrap1.b<<",n="<<n<<endl;
cout<<"sum[h]="<<sum1<<",sum[2h]="<<sum2<<",Error="<<error<<endl;
return 0;
}
/*Input and Output for Trapezoidal Method
Enter the value of a :0
Enter the value of b :1
sum[h]=0,sum[2h]=0,Error=0
sum[h]=0,sum[2h]=0,Error=0
sum[h]=0,sum[2h]=0,Error=0
sum[h]=0,sum[2h]=0,Error=0
sum[h]=0,sum[2h]=0,Error=0
sum[h]=0,sum[2h]=0,Error=0
sum[h]=0,sum[2h]=0,Error=0
sum[h]=0,sum[2h]=0,Error=0
sum[h]=0,sum[2h]=0,Error=0
sum[h]=0.407302,sum[2h]=0,Error=0
sum[h]=0.407302,sum[2h]=0,Error=0
sum[h]=0.407302,sum[2h]=0,Error=0
sum[h]=0.407302,sum[2h]=0,Error=0
a=0,b=1,n=10
sum[h]=0.407302,sum[2h]=0.744368,Error=0.112355
*/