/* Program 8.3 RKM 4th Order Method for solving First order
Differential Equation by Dr. RM. Somasundaram & Rm. Chandrasekaran */
class RKM
{
public :
double formula(double index1,double index2);
};
#include<stdio.h>
#include<conio.h>
#include<iostream.h>
#include<math.h>
#include<iomanip.h>
double RKM::formula(double index1,double index2)
{
// Function Used here is (3x+(y/2))
return (3*index1+(index2/2));
}
void main()
{
RKM aRKM;
double
x[20],y[20],ye[20],ym[20],f[20],exact[20],yp[20],fm[20],ys[20],gh[20],yr[20];
int k = 4,i;
int kk = 2 * k;
double h,hh,ak1,ak2,ak3,ak4,ak;
clrscr();
h=0.1;
x[0]=0.0;
y[0]=1.0;
for(i=1;i<=kk;i++)
{
x[i]=x[0]+i*h;
}
for(i=1;i<=kk;i++)
{
f[i] = aRKM.formula(x[i],y[i]);
y[i+1] = y[i] +h * f[i];
// exact[i] = 3.0 * exp(x[i]) - x[i] * x[i] -2.0 * x[i] -
2.0;
}
hh = 0.5 * h;
yr[0] = 1.0;
for(i=0;i<=kk;i++)
{
ak1 = h * aRKM.formula(x[i],yr[i]);
ak2 = h * aRKM.formula(x[i] + hh,yr[i] + 0.5 * ak1);
ak3 = h * aRKM.formula(x[i] + hh,yr[i] + 0.5 * ak2);
ak4 = h * aRKM.formula(x[i] + h,yr[i] +ak3);
ak = (ak1 + 2.0 * ak2 + 2.0 * ak3 +ak4)/6.0;
yr[i+1] = yr[i] + ak;
}
cout<<"\n\tStep Length h ="<<h<<endl;
cout<<"\t x \tf \t yr"<<endl;
for(i=1;i<=kk;i++)
{
cout<<setw(12)<<setprecision(6)<<x[i];
cout<<setw(12)<<setprecision(6)<<f[i];
cout<<setw(12)<<setprecision(6)<<yr[i]<<endl;
}
getch();
}
/*
________________________________________________________________________________
Step Length h =0.1
x f yr
0.1 2.035646 1.066524
0.2 2.437428 1.167222
0.3 2.859299 1.303845
0.4 3.302264 1.478236
0.5 3.767378 1.69233
0.6 4.255747 1.948164
0.7 4.768534 2.247878
0.8 5.306961 2.593721
*/