/* Program 8.4 Milne Method for solving ODE
by Dr. RM. Somasundaram & Rm. Chandrasekaran */
class RKM
{
public :
double formula(double index1,double index2);
};
#include<stdio.h>
#include<conio.h>
#include<iostream.h>
#include<math.h>
#include<iomanip.h>
double RKM::formula(double x1,double x2)
{
// return (3*index1+(index2/2));
// return index1*index1+index2;
return 1 / (x1+x2);
}
main()
{
RKM aRKM;
double
x[20],y[20],ye[20],ym[20],f[20],exact[20],yp[20],fm[20],ys[20],gh[20],yr[20];
int k = 4,i;
int kk = 2 * k;
double h,hh,ak1,ak2,ak3,ak4,ak;
clrscr();
// user values
x[0]=0;
h=0.2;
yr[1]=2;
yr[2]=2.09333;
yr[3]=2.1755;
yr[4]=2.2493;
for(i=1;i<=kk;i++)
{
x[i]=x[0]+i*h;
}
fm[1]=aRKM.formula(x[0],yr[1]);
fm[2]=aRKM.formula(x[1],yr[2]);
fm[3]=aRKM.formula(x[2],yr[3]);
fm[4]=aRKM.formula(x[3],yr[4]);
for(i=k;i<=kk;i++)
{
yp[i] = yr[i-3]+4*h*(2.0*fm[i-2]-fm[i-1]+2.0*fm[i])/3.0;
fm[i+1] = aRKM.formula(x[i],yp[i]);
ym[i] = yr[i-1]+h*(fm[i-1]+4.0*fm[i]+fm[i+1])/3.0;
fm[i+1] = aRKM.formula(x[i],ym[i]);
}
cout<<"\n\tStep Length h ="<<h<<endl;
cout<<"\tx \typ \t yc"<<endl;
for(i=4;i<=6;i++)
{
cout<<setw(12)<<setprecision(6)<<x[i];
cout<<setw(12)<<setprecision(6)<<yp[i]<<endl;
cout<<setw(12)<<setprecision(6)<<ym[i]<<endl;
}
getch();
}
/* Output For Milne Method
Step Length h =0.2
x yp yc
0.8 2.316199 2.316369
1 2.377959 2.378003
1.2 2.434995 2.294175
 */