/* Program 9.2 Bender-Schmidt Method for Solving Parabolic Equations
(one Dimensional Heat Equation) by Dr. RM. Somasundaram &
RM.Chandrasekaran */
#include <stdio.h>
#include<conio.h>
#include<iostream.h>
#include<iomanip.h>
class paraBolic{
public:
float u[25][25];
int n, itlast,i,j;
float a,b;
public:
void getValues(void);
void initValues(void);
void printValues(void);
void doIterate(void);
void printResults(void);
};
void paraBolic::getValues(void){
cout<<" Enter Values for N, ITLAST"<<endl;
cin>>n>>itlast;
cout<<"Enter values for Bountary conditions A, B"<<endl;
cin>>a>>b;
}
void paraBolic::initValues(void){
// Initialize all Values
for(i=0;i<n+1;i++)
for(j=0;j<n+1;j++)
u[i][j]=0.0;
// Initialize According to the Given Function
for(i=0;i<n+1;i++)
{
// Function used here is 4i-(i^2/2)
u[0][i]=((4*i) - (0.5* i*i));
cout<<setw(10)<<u[0][i];
}
for(i=0;i<n;i++)
{
u[i][0]=a;
u[i][n]=b;
// cout<<u[i][0]<<" "<<u[i][n+1]];
}
}
void paraBolic::printValues(void){
for(i=0;i<n+1;i++){
for(j=0;j<n+1;j++){
cout<<setw(6)<<setprecision(3)<<u[i][j];
}
cout<<endl;
}
}
void paraBolic::doIterate(void){
for(i=1;i<n+1;i++){ //for(j=0;j<n-2;j++)
for(j=0;j<n-1;j++) {
u[i][j+1] = 0.5 * (u[i-1][j] + u[i-1][j+2]);
}
}
}
void paraBolic::printResults(void){
clrscr();
cout<< " Check The Results"<<endl<<endl<<endl;
for(i=0;i<n+1;i++){
for(j=0;j<n+1;j++){
cout<<setw(6)<<setprecision(3)<<u[i][j];
}
cout<<endl;
}
getch();
}
void main(void){
clrscr();
paraBolic pB;
//n=8;itlast=10;
pB.getValues();
pB.initValues();
pB.printValues();
pB.doIterate();
pB.printResults();
getch();
}
/* Input
Enter Values for N, ITLAST
8
10
Enter values for Bountary conditions A, B
0
0
/* Output 
Check The Results
0 3.5 6 7.5 8 7.5 6 3.5 0
0 3 5.5 7 7.5 7 5.5 3 0
0 2.75 5 6.5 7 6.5 5 2.75 0
0 2.5 4.625 6 6.5 6 4.625 2.5 0
0 2.313 4.25 5.563 6 5.563 4.25 2.313 0
0 2.125 3.938 5.125 5.563 5.125 3.938 2.125 0
0 1.969 3.625 4.75 5.125 4.75 3.625 1.969 0
0 1.813 3.359 4.375 4.75 4.375 3.359 1.813 0
0 1.68 3.094 4.055 4.375 4.055 3.094 1.68 0
*/