/* Program 1.6 GRAFFE Root Squaring Method
by Dr. RM. Somasundaram & Rm. Chandrasekaran */
// GRAFFE TABLE
#include <iostream.h>
#include <conio.h>
#include <iomanip.h>
#include <stdlib.h>
#include <math.h>
class Graffe {
float B[10],SCF,t,SUM,S,temp;
int i,DEG,j,k,ii,M;
public :
void doCalculate(float A[10],int N,int MIT){
DEG = N;
t=1.0/DEG;
SCF=pow(fabs(A[N]),t);
cout<<"SCALED FACTOR = "<<SCF<<endl;
// cout<<"DERIVED COEFFICIENTS "<<endl;
// cout<<"SCALED COEFFICIENTS M = 1"<<endl;
for(i=1;i<=N;i++) {
A[i]/=pow(SCF,i);
// cout<<"A[i] value "<< A[i]<<endl;
}
M=2;
for (ii=1;ii<=MIT;ii++) {
// cout<<"ITER NO "<<ii<<" M = "<<M<<endl;
for (i=1;i<=N;i++) {
S=1.0;
k=i;
j=i;
SUM=0.0;
Lab1:
k=k-1;
j=j+1;
if (k<=0)
goto L1;
if (j<=N)
S=-S;
else
goto L2;
SUM+=(2.0 * S * A[k] * A[j]);
goto Lab1;
L1:
if(j<=N)
B[i]=(A[i] * A[i])+ SUM-(2.0*S*A[j]);
else
goto L2;
goto L3;
L2:
B[i]=(A[i]*A[i])+SUM;
L3:
// cout<<B[i]<<endl;
}
for (i=1;i<=N;i++)
A[i]=B[i];
M=2.0*M;
}
DEG=M/2;
B[1]=SCF * pow(A[1],(1.0/DEG));
for(i=2;i<=N;i++) {
temp = 1.0/DEG;
B[i]= SCF * pow((A[i] / A[i-1]), temp);
}
cout<<"ABSOLUTE ROOTS OF THE EQUATION ARE"<<endl;
for(i=1;i<=N;i++)
cout<<"X["<<i<<"] = "<<B[i]<<endl;
}
};
void main() {
float A[10];
int N,MIT,i;
Graffe g;
clrscr();

cout<<"Enter Value for N : ";
cin>>N;
cout<<"Enter the Value for MIT : ";
cin>>MIT;
cout<<"Enter the N values : ";
for(i=1;i<=N;i++) {
cin>>A[i];
}
g.doCalculate(A,N,MIT);
}
/*
____________________________________________________________________
 Input and Output for Graffe Root Square Method
Enter Value for N : 3
Enter the Value for MIT : 3
Enter the N values : -2 -5 6
SCALED FACTOR 1.817121
ABSOLUTE ROOTS OF THE EQUATION ARE
X[1] = 3.014443
X[2] = 1.991425
X[3] = 0.999494
*/