/* Program 2.1 GAUSS ELIMINATION MEthod
by Dr. RM. Somasundaram & Rm. Chandrasekaran */
#include <iostream.h>
#include <conio.h>
#include <iomanip.h>
#include <stdlib.h>
class Gauss {
public:
void doCalculate(float A[50][50],float B[50],int NEQ)
{
// FUNCTION TO SOLVE THE MATRIX EQUATION AX = B
// BY GUASSIAN ELIMINATION
int NO,i,j;
int N1,NP,NOW;
float D;
N1=NEQ-1;
// BEGIN ELIMINATION
for (NO=1;NO<=N1;NO++)
{
if (A[NO][NO]==0.0)
{
cout<<endl<<"*** ZERO DIAGONAL ELEMENT ARISES IN EQUATION ";
cout<<NO<<" DURING ELIMINATION ***"<<endl;
exit(0);
}
D = 1 / A[NO][NO];
NP = NO + 1;
for(j=NP;j<=NEQ;j++)
A[NO][j] = D * A[NO][j];
B[NO] = D * B[NO];
for (i = NP;i <= NEQ;i++)
{
for(j = NP;j <= NEQ;j++)
A[i][j] = A[i][j] - A[i][NO] * A[NO][j];
B[i] = B[i] - A[i][NO] * B[NO];
}
}
// BEGIN BACK SUBSTITUTION
B[NEQ] = B[NEQ] / A[NEQ][NEQ];
for (i = 1;i <= N1;i++)
{
NO = NEQ - i;
NP = NO + 1;
for(j = NP;j <= NEQ;j++)
B[NO] = B[NO] - A[NO][j] * B[j];
}
}
};
void main()
{
float A[50][50],B[50];
int NEQ,i,j;
Gauss g;
cout<<"Enter The number of Equations : ";
cin>>NEQ;
if(NEQ>50)
{
cout<<"*** SIZE OF INPUT MATRIX "<<NEQ<<" EXCEEDS ";
cout<<"THE MAXIMUM ALLOWABLE DIMENSION ***"<<endl;
exit(0);
}
cout<<"Enter the Input Matrix : "<<endl;
// READ INPUT MATRICES
for(i=1;i<=NEQ;i++)
for(j=1;j<=NEQ;j++)
cin>>A[i][j];
cout<<"Enter the RHS values : "<<endl;
for(i=1;i<=NEQ;i++)
cin>>B[i];
// ECHO CHECK OF INPUT DATA
cout<<endl<<"ECHO CHECK OF MATRIX"<<endl;
for(i=1;i<=NEQ;i++)
{
for(j=1;j<=NEQ;j++)
cout<<setw(5)<<A[i][j];
cout<<endl;
}
cout<<endl<<"ECHO CHECK OF INPUT VECTORS"<<endl;
for(i=1;i<=NEQ;i++)
cout<<setw(5)<<B[i];
cout<<endl;
g.doCalculate(A,B,NEQ);
cout<<endl<<"*** SOLUTION VECTOR ***"<<endl;
for(i=1;i<=NEQ;i++)
cout<<setprecision(2)<<B[i]<<" ";
}
/*____________________________________________________________________________
Input and output for Solution of System of Equations
Enter The number of Equations : 3
Enter the Input Matrix :
4 -1 -1
1 -5 1
1 2 6
Enter the RHS values :
-7 -10 9
ECHO CHECK OF MATRIX
4 -1 -1
1 -5 1
1 2 6
ECHO CHECK OF INPUT VECTORS
-7 -10 9
*** SOLUTION VECTOR ***
-1 2 1
*/