/* Program 2.2 by GAUSS Jordan Method
by Dr. RM. Somasundaram & Rm. Chandrasekaran */
//GAUSS JORDAN ELIMINATION 1
#include <iostream.h>
#include <conio.h>
#include <iomanip.h>
#include <stdlib.h>
class Jordan{
public:
void doCalculate(float A[50][50],int NEQ, int N1)
{
int N,j,i;
float D,D1;
for(N=1;N<=NEQ;N++)
{
if(A[N][N]==0)
{
cout<<endl<<"*** ZERO DIAGONAL ELEMENT ARISES IN EQUATION ";
cout<<N<<" DURING EXECUTION ***"<<endl;
exit(0);
}
D = 1 / A[N][N];
for (j=1; j<=N1;j++)
A[N][j] = D * A[N][j];
for (i=1;i<=NEQ;i++)
{
if (i==N)
i=i+1;
if (i>NEQ)
return;
D1=A[i][N];
for(j=1;j<=N1;j++)
A[i][j]=A[i][j]-D1*A[N][j];
}
A[N][N]=1;
}
}
};
void main()
{
float A[50][50],B[50],temp;
int NEQ,i,j,IFLAC,N1;
Jordan jo;
clrscr();
cout<<"** SET FLAG 0 FOR MATRIX INVERSION AND 1 FOR SOLUTION **"<<endl;
cout<<"Enter Flag Value : ";
cin>>IFLAC;
cout<<"Enter number of Equations :";
cin>>NEQ;
N1 = 2 * NEQ;
if (IFLAC==1)
N1 = NEQ + 1;
if(N1>50)
{
cout<<"*** SIZE OF INPUT MATRIX "<<NEQ<<" EXCEEDS ";
cout<<"THE MAXIMUM ALLOWABLE DIMENSION ***"<<endl;
exit(0);
}
// READ INPUT MATRICES
cout<<"Enter the Input Matrix : "<<endl;
for(i=1;i<=NEQ;i++)
for(j=1;j<=N1;j++)
cin>>A[i][j];
cout<<endl<<"ECHO CHECK OF INPUT "<<endl;
for(i=1;i<=NEQ;i++)
{
for(j=1;j<=N1;j++)
{
cout<<setw(5)<<A[i][j];
}
cout<<endl;
}
jo.doCalculate(A,NEQ,N1);
cout<<endl<<endl<<"OUTPUT"<<endl<<endl;
for(i=1;i<=NEQ;i++)
{
for(j=1;j<=N1;j++)
cout<<setprecision(2)<<setw(5)<<A[i][j];
cout<<endl;
}
}
/*
___________________________________________________________________________
Input and output for Matrix Inversion
 SET FLAG 0 FOR MATRIX INVERSION AND 1 FOR SOLUTION **
Enter Flag Value : 0
Enter number of Equations :4
Enter the Input Matrix :
2 2 4 -2 1 0 0 0
1 3 2 1 0 1 0 0
3 1 3 1 0 0 1 0
1 3 4 2 0 0 0 1
Appendix 176
ECHO CHECK OF INPUT
2 2 4 -2 1 0 0 0
1 3 2 1 0 1 0 0
3 1 3 1 0 0 1 0
1 3 4 2 0 0 0 1
OUTPUT
1 0 0 0-0.05 0.3 0.4 -0.4
0 1 0 0 0.02 0.57-0.13 -0.2
0 0 1 0 0.13-0.47-0.07 0.4
0 0 0 1-0.27-0.07 0.13 0.2
_______________________________________________________________________
/*Input and output for Solution of System of Equations
** SET FLAG 0 FOR MATRIX INVERSION AND 1 FOR SOLUTION **
Enter Flag Value : 1
Enter number of Equations :4
Enter the Input Matrix :
2 2 4 -2 10
1 3 2 1 17
3 1 3 1 18
1 3 4 2 27
ECHO CHECK OF INPUT
2 2 4 -2 10
1 3 2 1 17
3 1 3 1 18
1 3 4 2 27
OUTPUT
1 0 0 0 1
0 1 0 0 2
0 0 1 0 3
0 0 0 1 4
*/