/* Program 2.5 Jacobian Method
by Dr. RM. Somasundaram & Rm. Chandrasekaran */
//enum bool {flag,false=0,true=1};
class JACO
{
public :
double a[10][10],f[10],xs[10],xf[10];
int k;
double ep;
public :
void doProcessing(void);
};
#include<stdio.h>
#include<iostream.h>
#include<math.h>
#include<conio.h>
void JACO::doProcessing(void)
{
int i,j;
double sum;
for(i=1;i<=k;i++)
{
sum=0;
for(j=1;j<=k;j++)
{
if(j==i)
{
continue;
}
else
{
sum=sum + a[i][j] * xs[j];
}
}
xf[i]=(f[i]-sum)/a[i][i];
}
}
int main()
{
JACO aJACO;
int m,i,j,jm,jp,k;
int ismax = 500;
int istep = 1;
int flag = 0;
cout<<"\n\t Enter Tolerence :";
cin>>aJACO.ep;
cout<<"\n\t Enter values of k :";
cin>>aJACO.k;
k=aJACO.k;
cout<<"\n\t Enter a[i][j] :"<<endl;
for(i=1;i<=k;i++)
{
for(j=1;j<=k;j++)
{
cin>>aJACO.a[i][j];
}
}
for(i=1;i<=k;i++)
{
for(j=1;j<=k;j++)
{
cout<<aJACO.a[i][j]<<" ";
}
}
cout<<"\n\t Enter values for f[i] "<<endl;
for(i=1;i<=k;i++)
{
cin>>aJACO.f[i];
}
for(i=1;i<=k;i++)
{
cout<<aJACO.f[i]<<" ";
}
cout<<endl;
for(i=1;i<=k;i++)
{
aJACO.xs[i]=0.0;
}
while(istep < ismax)
{
aJACO.doProcessing();
for(i=1;i<=k;i++)
{
if(fabs(aJACO.xf[i] - aJACO.xs[i]) >aJACO.ep)
{
break;
}
else
{
flag=1;
continue;
}
}
if(flag==1)
{
break;
}
for(i=1;i<=k;i++)
{
aJACO.xs[i]=aJACO.xf[i];
}
cout<<"istep="<<istep<<"xf[i]="<<endl;
{
for(i=1;i<=k;i++)
{
cout<<aJACO.xf[i]<<" ";
}
cout<<endl;
istep=istep +1;
}
if(istep >= ismax)
{
cout<<"\n\t The Final steps values are = ";
for(i=1;i<=k;i++)
{
cout<<aJACO.f[i]<<" ";
}
cout<<endl;
}
else
{
cout<<"\n\t Final Coverage solution "<<endl;
cout<<"\n\t istep="<<istep<<"aJACO.ep="<<aJACO.ep<<endl;
cout<<"\n\t Value of xf[i] = "<<endl;
for(i=1;i<=k;i++)
{
cout<<aJACO.xf[i]<<" ";
}
}
getch();
}
}
/*
____________________________________________________________________________
 Input and Output for Jacobian Method
Enter Tolerence : 0.00001
Enter values of k : 3
Enter a[i][j] :
10 1 -1
1 10 1
-1 1 10
Enter values for f[i]
11.19 28.08 35.61
Appendix 185
istep=1xf[i]=
1.119 2.808 3.561
Final Coverage solution
istep=2aJACO.ep=1e-05
Value of xf[i] =
1.119 2.808 3.561 istep=2xf[i]=
1.1943 2.34 3.3921
Final Coverage solution
istep=3aJACO.ep=1e-05
Value of xf[i] =
1.1943 2.34 3.3921 istep=3xf[i]=
1.22421 2.34936 3.44643
Final Coverage solution
istep=4aJACO.ep=1e-05
Value of xf[i] =
1.22421 2.34936 3.44643 istep=4xf[i]=
1.228707 2.340936 3.448485
Final Coverage solution
istep=5aJACO.ep=1e-05
Value of xf[i] =
1.228707 2.340936 3.448485 istep=5xf[i]=
1.229755 2.340281 3.449777
Final Coverage solution
istep=6aJACO.ep=1e-05
Value of xf[i] =
1.229755 2.340281 3.449777 istep=6xf[i]=
1.22995 2.340047 3.449947
Final Coverage solution
istep=7aJACO.ep=1e-05
Value of xf[i] =
1.22995 2.340047 3.449947 istep=7xf[i]=
1.22999 2.34001 3.44999
Appendix 186
Final Coverage solution
istep=8aJACO.ep=1e-05
Value of xf[i] =
1.22999 2.34001 3.44999
*/