/* Program 2.6 by SOR/Gauss Seidal Method
by Dr. RM. Somasundaram & Rm. Chandrasekaran
Note : For GaussSeidal Seidal Change Omega = 1; */
class SOR_GaussSeidal
{
public :
double a[10][10],f[10],xs[10],xf[10];
double prev[10];
int k;
double ep;
double omega;
public :
void doProcessing(void);
};
#include<stdio.h>
#include<iostream.h>
#include<math.h>
#include<conio.h>
void SOR_GaussSeidal::doProcessing(void)
{
int i,j;
double sum1,sum2;
int kp = k+1;
for(i=1;i<=k;i++)
{
sum1=0.0;
sum2=0.0;
for(j=1;j<=i-1;j++)
{
if(j==i)
{
sum1=0.0;
break;
}
else
{
sum1 = sum1 + a[i][j] * xf[j];
}
}
for(j=i+1;j<=k;j++)
{
if(i==k)
{
sum2=0.0;
break;
}
else
{
sum2 = sum2 + a[i][j] * xs[j];
}
}
xf[i] = (a[i][kp]-sum1-sum2)/a[i][i];
xf[i] = xs[i] + omega * (xf[i] - xs[i]);
}
}
int main()
{
SOR_GaussSeidal aSOR_GaussSeidal;
clrscr();
int i=0,j=0,k=0;
int ismax = 500;
int istep = 1;
int flag = 0;
cout<<"\n\t Enter Tolerence :";
cin>>aSOR_GaussSeidal.ep;
cout<<"\n\t Enter values of k :";
cin>>aSOR_GaussSeidal.k;
k=aSOR_GaussSeidal.k;
cout<<"\n\t Enter Augmented matrix a[i][j] :"<<endl;
for(i=1;i<=k;i++)
{
for(j=1;j<=k+1;j++)
{
cin>>aSOR_GaussSeidal.a[i][j];
}
}
for(i=1;i<=k;i++)
{
for(j=1;j<=k;j++)
{
cout<<aSOR_GaussSeidal.a[i][j]<<" ";
}
cout<<endl;
}
/** Give omega 1 for GaussSeidal Seidal Method and more for other one **/
cout<<"\n\t Enter the value for omega :"<<endl;
cin>>aSOR_GaussSeidal.omega;
for(i=1;i<=k;i++)
{
aSOR_GaussSeidal.xs[i]=0.0;
}
while(istep < ismax)
{
aSOR_GaussSeidal.doProcessing();
for(i=1;i<=k;i++)
{
if(fabs(aSOR_GaussSeidal.xf[i] - aSOR_GaussSeidal.xs[i]) >aSOR_GaussSeidal.ep)
{
break;
}
else
{
flag=1;
continue;
}
}
if(flag==1)
{
break;
}
for (i=1;i<=k;i++)
{
aSOR_GaussSeidal.xs[i]=aSOR_GaussSeidal.xf[i];
}
cout<<"\nistep="<<istep<<",omega="<<aSOR_GaussSeidal.omega<<"xf[i]="<<endl;
{
for(i=1;i<=k;i++)
{
cout<<aSOR_GaussSeidal.xf[i]<<" ";
}
cout<<endl;
istep=istep +1;
}
if(istep >= ismax)
{
cout<<"\n\t The Final steps values are = ";
for(i=1;i<=k;i++)
{
cout<<aSOR_GaussSeidal.f[i]<<" ";
}
cout<<endl;
}
else
{
cout<<"\n\t Final Coverage solution "<<endl;
cout<<"\n\t istep="<<istep<<"aSOR_GaussSeidal.ep="<<aSOR_GaussSeidal.ep<<endl;
cout<<"\n\t Value of xf[i] = "<<endl;
for(i=1;i<=k;i++)
{
cout<<aSOR_GaussSeidal.xf[i]<<" ";
}
}
getch();
}
}