/* Program 4.1 Least Square Method for Curve fitting
by Dr. RM. Somasundaram & RM. Chandrasekaran
*/
// Least Square
#include <iostream.h>
#include <conio.h>
#include <iomanip.h>
#include <stdlib.h>
#include <math.h>
/*class LeastSqu {
public:
double C[20];
public:
void leastSqSolve(double A[20][20], int NEQ, double C[20]);
};
*/
double C[20];
void leastSqSolve(double A[20][20], int NEQ)
{
int k,i,j,NL,N, N1, M1J, M, M1;
NL=NEQ -1;
for(N=1;N<=NL;N++){
N1 = N+1;
for(j=N1;j<=NEQ;j++){
A[N][j]=A[N][j]/A[N][N];
}
for(i=N1;i<=NEQ;i++){
if (A[N][i]== 0.0)
continue;
for(j=i;j<=NEQ;j++){
A[i][j] = A[i][j] - A[i][N]* A[N][j];
A[j][i] = A[i][j];
}
C[i] = C[i] - A[N][i] * C[N];
}
C[N] = C[N] / A[N][N];
}
M = NEQ;
for(N=1; N<=NL;N++){
M1 =M;
M = M - 1;
for(j=M1;j<=NEQ;j++){
C[M] = C[M] - C[j] * A[M][j];
}
}
}
void main() {
int N,i,NDATA, M, MPI, JM1,j,NN,k, IM1, ii,jj,NEQ;
double A[20][20],D[20][20],X[20], Y[20], t1,t2;
clrscr();
cout<<"Enter values for NDATA, M ; "<<endl;
cin>>NDATA>>M;
cout<<"Number of Data "<<NDATA<<"\tOrder of Curve Required "
<<M<<endl;
cout<<"Enter X values"<<endl;
for(i=1;i<=NDATA;i++){
cin>>t1;
X[i]=t1;
// cout<<"\t"<<X[i]<<endl;
}
cout<<"Enter Y values"<<endl;
for(i=1;i<=NDATA;i++){
cin>>t1;
Y[i]=t1;
// cout<<"\t"<<Y[i]<<endl;
}
MPI = M +1;
for(i=1;i<=NDATA;i++){
A[i][1] = 1.0;
for(j=2;j<=MPI;j++){
JM1 = j -1;
A[i][j] = A[i][JM1] * X[i];
}
}
for(i=1;i<=MPI;i++){
C[i] = 0.0;
for(j=1;j<=NDATA;j++){
C[i] = C[i]+A[j][i] * Y[j];
}
}
for(i=1;i<=MPI;i++){
for(j=1;j<=MPI;j++){
D[i][j]=0.0;
for(k=1;k<=NDATA;k++){
D[i][j]=D[i][j]+A[k][i]*A[k][j];
}
}
}
//LeastSqu Ls;
for(i=1;i< MPI;i++){
cout<<"C output"<< C[i]<<endl;
}
leastSqSolve(D, MPI);
for(i=1;i<MPI;i++){
IM1 = i -1 ;
cout <<"\n ALPHA "<<IM1+1<<" = "<< C[i];
}
}
/*
Enter values for NDATA, M ;
5 3
Number of Data 5 Order of Curve Required 3
Enter X values
5
10
15
20
25
Enter Y values
16
19
23
26
30
ALPHA 1 = 12.8
ALPHA 2 = 0.614286
ALPHA 3 = 0.002857
_________________________________________________________________________________
*/