/* Program 7.3 Rhomberg Method for evaluating an integral
by Dr. RM. Somasundaram & Rm. Chandrasekaran */
class Rhomberg
{
public :
double a;
double b;
double epsilon;
public :
double formula(double index);
};
#include<stdio.h>
#include<iostream.h>
#include<math.h>
#include<conio.h>
double Rhomberg::formula(double index)
{
return exp(-index * index);
//return (1/(1+(index*index)));
// return (sin(index)/index);
}
main()
{
Rhomberg aRhomberg;
double x[100],temp[100];
double h=0.5,ends=0.0;
double a=0.0,b=0.0;
double su=0.0;
double sum=0.0;
double sum1=0.0;
double sum2=0.0;
double sum3=0.0;
double sum4=0.0;
double sum12=0.0;
double sum23=0.0;
double sum13=0.0;
double sum123=0.0;
double n=8,j;
clrscr();
cout<<"\n\tEnter the value of a :";
cin>>aRhomberg.a;
cout<<"\n\tEnter the value of b :";
cin>>aRhomberg.b;
cout<<"\n\tEnter the valur for Epsilon :";
cin>>aRhomberg.epsilon;
a=aRhomberg.a;
b=aRhomberg.b;
h = (b-a)/n;
ends=1.0 + aRhomberg.formula(b);
sum=0.0;
for(j=1;j<=n-1;j++)
{
x[j] = a + j*h;

temp[j] = aRhomberg.formula(x[j]);
sum = sum +2.0 * temp[j];
}
sum1 = 0.5 * (ends + sum) * h;
sum=0.0;
for(j=2;j<=n-2;j+=2)
{
sum = sum + 2.0 * temp[j];
}
sum2 = h * (ends + sum);
sum=0.0;
for(j=4;j<=n-2;j+=4)
{
sum = sum + 2.0 * temp[j];
}
sum3 = 2.0 * h * (ends+sum);
sum12 = ( 4.0 * sum1 - sum2 ) / 3.0;
sum23 = ( 4.0 * sum2 - sum3 ) / 3.0;
sum123 = (16.0 * sum12 - sum23) / 15.0;
cout<<"\n\ta="<<aRhomberg.a<<",\tb="<<aRhomberg.b<<",\tTolerence="<<aRhomberg.epsilon<<endl;
cout<<"\n\tsum[h]="<<sum1<<",\tsum[2h]="<<sum2<<",\tsum[4h]="<<sum3<<endl;
cout<<"\n\tsum12="<<sum12<<",\tsum23="<<sum23<<",\tsum123="<<sum123<<endl;
return 0;
getch();
}
/* Input and Output for Rhomberg Methods
Enter the value of a :0
Enter the value of b :1
Enter the valur for Epsilon :0.00001
a=0, b=1, Tolerence=1e-05
sum[h]=0.784747, sum[2h]=0.782794,
sum[4h]=0.775
sum12=0.785398, sum23=0.785392, sum123=0.785399
*/