/* Program 8.1 Euler Methods for solving ordinary differential
Equation by Dr. RM. Somasundaram & Rm. Chandrasekaran */
//EULER METHODS
class Euler
{
public :
double formula(double index1,double index2);
};
#include<stdio.h>
#include<conio.h>
#include<iostream.h>
#include<math.h>
#include <iomanip.h>
double Euler::formula(double index1,double index2)
{
// Function 3*x^2 +y
return (3*(index1*index1) + (index2));
}
void main()
{
Euler aEuler;
double
x[20],y[20],yy[20],yh[20],ye[20],f[20],exact[20],ys[20],gh[20],fm[20];
double ghh[20], yhh[20];
int kk=5;
int i;
double h = 0.25;
x[0] = 0.0;
y[0] = 4.0;
yy[0]= 4.0;
yh[0]= 4.0;
yhh[0]= 4.0;
for(i=1;i<=kk;i++)
{
x[i]=x[0] + i * h;
}
for(i=0;i<=kk;i++)
{
f[i] = aEuler.formula(x[i],y[i]);
y[i+1] = y[i] + h * f[i];
yy[i+1] = (yy[i] + h * x[i+1] * x[i+1])/(1.0-h);
exact[i] = 10.0 * exp(x[i])-3*(x[i]*x[i]+2.0 * x[i]+2.0);
}
for(i=0;i<=kk;i++)
{
f[i] = aEuler.formula(x[i],yh[i]);
ys[i+1] = yh[i] + h * f[i];
gh[i+1] = aEuler.formula(x[i+1],ys[i+1]);
yh[i+1] = yh[i] + 0.5 * h * (f[i] + gh[i+1]);
ghh[i+1] = yh[i]+h*0.5*aEuler.formula(x[i],yh[i]);
yhh[i+1] = yhh[i] + h *
aEuler.formula(x[i]+h*0.5,ghh[i+1]);
}
clrscr();
cout<<"\n\tStep Length h="<<h<<endl;
cout<<"\t x\t y\t Modified \tImproved \t Exact"<<endl;
for(i=0;i<70;i++)
cout<<"-";
cout<<endl;
for(i=0;i<=kk;i++)
{
cout<<setw(12)<<x[i]<<setw(12)<<y[i]<<setw(12)<<yh[i]<<setw(12)<<yhh[i]<<setw(12)<<exact[i]<<endl;
}
getch();
}
/* Output for Euler Method
Step Length h=0.25
x y Modified Improved Exact
----------------------------------------------------------------------------
0 4 4 4 4
0.25 5 5.148438 5.136719 5.152754
0.5 6.296875 6.719482 6.696045 6.737213
0.75 8.058594 8.937462 8.902306 8.9825
1 10.495117 12.089795 12.04292 12.182818
1.25 13.868896 16.544737 16.486143 16.71593
*/