/* Program 8.2 Taylor Series Method for Solving an ODE
by Dr. RM. Somasundaram & Rm. Chandrasekaran */
// TAYLOR Series
// y = F (X,Y)
// interval 0 to 1
// h increment = 0.1
#include <iostream.h>
#include <conio.h>
#include <fstream.h>
#include <iomanip.h>
#include <stdlib.h>
#include <math.h>
float f(float,float);
float fp(float,float);
float fpp(float,float);
void main() {
clrscr();
float h=0.1,e=2.718282;
float x=0.0;
float y=1.0;
cout<<"N F3(NUM) "<<endl;
while (x<=1.1) {
// MODIFY THIS LINE FOR INCREASED ACCURACY
y=y+h*f(x,y)+(h*h/2.0)*fp(x,y)+(h*h*h/6.0)*fpp(x,y);
x+=h;
cout<<x<<"\t"<<setprecision(5)<<y<<"\n";
}
getch();
}
// USER FUNCTIONS
float f(float a,float b) {
return (a*a-b);
}
float fp(float a,float b) {
return (2*a-(a*a-b));
}
float fpp(float a,float b) {
return (2 - (2*a-(a*a-b)));
}

/*
_____________________________________________________________________________________________________________________________
 Output for Taylors Method
N F3(NUM)
0.1 0.90517
0.2 0.82128
0.3 0.74919
0.4 0.68969
0.5 0.64348
0.6 0.6112
0.7 0.59343
0.8 0.59069
0.9 0.60345
1 0.63214
1.1 0.67715
*/