/* Program 9.1 Liebmanns Method for Solving Laplace Equations
by Dr. RM. Somasundaram & Rm. Chandrasekaran */
#include<conio.h>
#include<math.h>
#include<iostream.h>
#include<iomanip.h>
class Laplace {
public:
float U[25][25];
int ITLAST, N,i,j,M,ITERA;
public:
void getValues(void);
void initBoundaryConditions(void);
void printBoundaryConditions(void);
void doIterate(void);
};
void Laplace::getValues(void){
cout<<"Enter ITLAST\tN\t"<<endl;
cin>>ITLAST>>N;
}
void Laplace::initBoundaryConditions(void){
for(i=0;i<N;i++)
for(j=0;j<N;j++) U[i][j]=0.0;
for(j=0;j<N;j++){
cout<<"\nU[0]["<<j<<"]";
cin>>U[0][j];
}
for(j=0;j<N;j++){
cout<<"\nU[0]["<<j<<"]="<<U[0][j];
}
cout<<endl;
for(j=0;j<N;j++){
cout<<"\nU["<<N-1<<"]["<<j<<"]";
cin>>U[N-1][j];
}
for(j=0;j<N;j++){
cout<<"U["<<N-1<<"]["<<j<<"]=="<<U[N-1][j]<<endl;
}
cout<<endl;
for(i=1;i<N-1;i++){
cout<<"U["<<i<<"][0]"<<endl;
cin>>U[i][0];
}
for(i=1;i<N-1;i++){
cout<<"U["<<i<<"][0]="<<U[i][0]<<endl;
}
cout<<endl;
cout<<endl;
for(i=1;i<N-1;i++){
cout<<"U["<<i<<"]["<<N-1<<"]";
cin>>U[i][N-1];
}
for(i=1;i<N-1;i++){
cout<<"U["<<i<<"]["<<N-1<<"]="<<U[i][N-1]<<endl;
}
}
void Laplace::printBoundaryConditions(void){
//clrscr();
//printf("Entered Boundary Value Problem \n");
cout<<"Please check the boundary values given"<<endl;
for(i=1;i<N;i++) {
for(j=1;j<N;j++){
cout<<"U["<<i<<"]["<<j<<"]="<<U[i][j];
}
cout<<endl;
}
}
void Laplace::doIterate(void){
for(i=1;i<N-1;i++) {
cout<<endl;;
for(j=1;j<N-1;j++) {
U[i][j] = (U[i][j+1] + U[i][j-1] +U[i-1][j] + U[i+1][j])/
4.0;
cout<<"U["<<i<<"]["<<j<<"]="<<setw(6)<<setprecision(3)<<U[i][j];
cout<<" ";
}
}
}
void main() {
int wait;
clrscr();
getch();
Laplace Lp;
Lp.ITERA = 0;
Lp.getValues();

Lp.initBoundaryConditions();
Lp.printBoundaryConditions();
Do_again:
Lp.doIterate();
cout<<"ITRA="<<Lp.ITERA<<"\t\tITRLAST="<<Lp.ITLAST;
Lp.ITERA = Lp.ITERA +1;
if (Lp.ITERA <= Lp.ITLAST){
cout<<endl;
cout<<"\nGoing again for iter ="<<Lp.ITERA;
goto Do_again;
}
else
cin>>wait;
}
/* Input
ITLAST=10, N = 5
0 0 0 0 0
12 13 14 15 16
3 6 9
1 4 9
/* Output
. . . . . .
Going again for iter =6
U[1][1]= 2.897 U[1][2]= 2.763 U[1][3]= 2.31
U[2][1]= 6.049 U[2][2]= 6.013 U[2][3]= 5.533
U[3][1]= 9.453 U[3][2]= 9.819 U[3][3]= 9.838 ITRA=6
ITRLAST=10
Going again for iter =7
U[1][1]= 2.953 U[1][2]= 2.819 U[1][3]= 2.338
U[2][1]= 6.105 U[2][2]= 6.069 U[2][3]= 5.561
U[3][1]= 9.481 U[3][2]= 9.847 U[3][3]= 9.852 ITRA=7
ITRLAST=10
Going again for iter =8
U[1][1]= 2.981 U[1][2]= 2.847 U[1][3]= 2.352
U[2][1]= 6.133 U[2][2]= 6.097 U[2][3]= 5.575
U[3][1]= 9.495 U[3][2]= 9.861 U[3][3]= 9.859 ITRA=8
ITRLAST=10
Going again for iter =9
U[1][1]= 2.995 U[1][2]= 2.861 U[1][3]= 2.359
Appendix 219
U[2][1]= 6.147 U[2][2]= 6.111 U[2][3]= 5.582
U[3][1]= 9.502 U[3][2]= 9.868 U[3][3]= 9.863 ITRA=9
ITRLAST=10
Going again for iter =10
U[1][1]= 3.002 U[1][2]= 2.868 U[1][3]= 2.363
U[2][1]= 6.154 U[2][2]= 6.118 U[2][3]= 5.586
U[3][1]= 9.505 U[3][2]= 9.872 U[3][3]= 9.864 ITRA=10
ITRLAST=10
*/